import org.junit.Test;
import org.junit.Assert;

/**
 * Simple test for our dynamic array class.
 */
public class LinkedListTest {

  /**
   * Test the constructor.
   */
  @Test
  public void constructorTest() {
    LinkedList<String> list = new LinkedList<String>();
    Assert.assertEquals(null, list.first());
    Assert.assertEquals(null, list.last());
    Assert.assertEquals(0, list.size());
  }

  /**
   * Test insert method.
   */
  @Test
  public void insertAfterTest() {

    // Insert four items in a non-straighforward order, and check that
    // afterwards the list looks as follows:
    //
    // first --> +-----+ --> +-----+ --> +-----+ --> +-----+ --> NULL
    //           +item1+     +item2+     +item3+     +item4+
    //  NULL <-- +-----+ <-- +-----+ <-- +-----+ <-- +-----+ <-- last
    
    LinkedList<String> list = new LinkedList<String>();
    LinkedListItem<String> item1 = new LinkedListItem<String>(new String());
    LinkedListItem<String> item2 = new LinkedListItem<String>(new String());
    LinkedListItem<String> item3 = new LinkedListItem<String>(new String());
    LinkedListItem<String> item4 = new LinkedListItem<String>(new String());
    list.insertAfter(null, item2);
    list.insertAfter(item2, item4);
    list.insertAfter(null, item1);
    list.insertAfter(item2, item3);
    System.out.print("Linked list after insertion of four items"
                     + " in random order:\n" + list.toString());

    Assert.assertEquals(4, list.size());
    Assert.assertEquals(item1, list.first());
    Assert.assertEquals(null, item1.previous);
    Assert.assertEquals(item2, item1.next);
    Assert.assertEquals(item1, item2.previous);
    Assert.assertEquals(item3, item2.next);
    Assert.assertEquals(item2, item3.previous);
    Assert.assertEquals(item4, item3.next);
    Assert.assertEquals(item3, item4.previous);
    Assert.assertEquals(null, item4.next);
    Assert.assertEquals(item4, list.last());
  }
}
